﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;

namespace WindowsFormsApplication1
{
    public partial class Form1 : Form
    {
        private DataTable dtMain = new DataTable();
        private DataColumn dcValue = new DataColumn("Value");

        public Form1()
        {
            InitializeComponent();

            dtMain.Columns.Add(dcValue);

            for (int i = 0; i < 30; i++)
            {
                DataRow dr = dtMain.NewRow();
                dr[dcValue] = i;

                dtMain.Rows.Add(dr);
            }

            dataGridView1.DataSource = DivideColumn(dtMain, dcValue, 15);
        }

        public DataTable DivideColumn(DataTable source, DataColumn column, int rowsPerColumn)
        {
            DataTable retTable = null;

            if (source != null && source.Columns.Contains(column.ColumnName) && source.Rows.Count > rowsPerColumn)
            {
                string baseColName = column.ColumnName;
                int numCols = (int)Math.Ceiling((double)source.Rows.Count / (double)rowsPerColumn);

                if (numCols > 0)
                {
                    retTable = new DataTable();
                    for (int i = 0; i < numCols; i++)
                    {
                        DataColumn newCol = new DataColumn(string.Format("{0}{1}", baseColName, i));
                        retTable.Columns.Add(newCol);
                    }

                    // Copy width-wise
                    //for (int i = 0; i < source.Rows.Count; i += numCols)
                    //{
                    //    DataRow dr = retTable.NewRow();

                    //    for (int j = 0; j < numCols; j++)
                    //    {
                    //        dr[baseColName + j.ToString()] = dtMain.Rows[i + j][column];
                    //    }

                    //    retTable.Rows.Add(dr);
                    //}

                    // Copy length-wise
                    for (int i = 0; i < rowsPerColumn; i++)
                    {
                        DataRow dr = retTable.NewRow();

                        for (int j = 0; j < numCols; j++)
                        {
                            int sourceCell = i + (j * rowsPerColumn);
                            if (sourceCell < source.Rows.Count)
                            {
                                dr[baseColName + j.ToString()] = dtMain.Rows[sourceCell][column];
                            }
                        }

                        retTable.Rows.Add(dr);
                    }
                }
            }

            return retTable;
        }
    }
}
